/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.sanskritlibrary.proxy;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.sanskritlibrary.Config;
import org.sanskritlibrary.IOAssistance;

/**
 *
 * @author ralph
 */
public class LoadHTML extends HttpServlet {
   
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        try {
            Config config = (Config) this.getServletContext().getAttribute("config");

            String htmlDirectory = config.catalogEntriesHTML;
            String text = request.getParameter("html");
            if (!text.endsWith(".html")) {
                text += ".html";
            }
            String fn = String.format("%s/%s", htmlDirectory, text);

            text = IOAssistance.readEntireFile(fn);
            sendHTML(response, text);
        } catch (Exception ex) {
            sendMessage(response, ex.getMessage());
        }
    }

    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
    }

    private void sendHTML(HttpServletResponse response, String html) throws IOException {
        response.setContentType("text/html; charset=UTF-8");
        PrintWriter pw = response.getWriter();
        pw.write(html);
    }

    private void sendMessage(HttpServletResponse response, String msg) throws IOException {
        response.setContentType("text/html; charset=UTF-8");
        PrintWriter pw = response.getWriter();
        pw.write(msg);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
