package org.sanskritlibrary.proxy;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.sanskritlibrary.Annotation;
import org.sanskritlibrary.Config;
import org.sanskritlibrary.LineInfo;
import org.sanskritlibrary.ManuscriptInfo;
import org.sanskritlibrary.TextFormatter;
import org.sanskritlibrary.TextStructure;
import org.sanskritlibrary.servlet.SanskritLibraryServlet;

/**
 *
 * @author ralph
 */
public class LoadImage extends SanskritLibraryServlet {

    //static String mss = "/Users/ralph/SanskritLibrary/LatestGrantFiles/mss";
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        String imageFile = null;
//        String mss = (String) this.getServletContext().getInitParameter("dataDirectory") + "mss";
        Config config = (Config)this.getServletContext().getAttribute("config");
        String type = request.getParameter("type");
        String image = request.getParameter("image");
        if (type.equals("folio")) {  // image of a verso and recto
            String mss = config.imagesSitaAnnotated;
            String manuscript = request.getParameter("manuscript");        
            if (manuscript == null || image==null) {
                PrintWriter pw = response.getWriter();
                pw.write(String.format("Parameter name or image is null"));
                return;
            } else {
                imageFile = String.format("%s/%s/%s.jpg", mss, manuscript, image);
            }
        } else if (type.equals("cropped")) {    // only verso or recto
            FileMap filemap = (FileMap) this.getServletContext().getAttribute("filemap");
            String key = request.getParameter("key");         // catalog file, e.g. penn0492
            String manuscriptDirectory = filemap.filemap.get(key);
            if (manuscriptDirectory == null) {
                PrintWriter pw = response.getWriter();
                pw.write(String.format("%s not found in filemap.xml", key));
                return;
            } else {
                if (!manuscriptDirectory.endsWith("/")) {
                    manuscriptDirectory += "/";
                }
                imageFile = String.format("%s%s%s", config.imagesCropped, manuscriptDirectory, image);
            }
        }

        try {
            response.setContentType("image/jpeg");
            FileInputStream fis = new FileInputStream(imageFile);
            byte[] b = new byte[fis.available()];
            fis.read(b);
            ServletOutputStream sos = response.getOutputStream();
            sos.write(b);
        } catch (Exception ex) {
            sendMessage(response, ex.getMessage());
        }
    }

    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
    }

    private void sendMessage(HttpServletResponse response, String msg) throws IOException {
        response.setContentType("text/html; charset=UTF-8");
        PrintWriter pw = response.getWriter();
        pw.write(msg);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
