/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.sanskritlibrary.proxy;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Hashtable;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.sanskritlibrary.servlet.SanskritLibraryServlet;
import org.sanskritlibrary.webservice.ByteBuffer;
import org.sanskritlibrary.webservice.UniversalProxy;

/**
 *
 * @author ralph
 */
public class MorphologicalAnalyzer extends SanskritLibraryServlet {


    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        String wordform = request.getParameter("wordform");
        ServletOutputStream out = null;
        if (wordform != null) {
            out = response.getOutputStream();
            UniversalProxy proxy = new UniversalProxy();
            Hashtable<String, String> h = createHashtable(request);
            h.put("Content-Type", "application/x-www-form-urlencoded; charset=UTF-8");
            String contentFormat = "wordform=%s&.submit=Submit+Query";
            String url = "http://archimedes.fas.harvard.edu/cgi-bin/analyze";
            String content = String.format(contentFormat, wordform);
            h.put("Content-Length", Integer.toString(content.length()));
            if (proxy.getResponse("POST", url, h, content.getBytes("UTF-8"))) {
                try {
                    proxy.getHeaders();
                    response.setContentType("text/html; charset=UTF-8");
                    ByteBuffer bb = proxy.getContent();
                    String result = new String(bb.content, 0, bb.len, "UTF-8");
                    String target = getCookieValue(request, "serverOptions", "deva");

                    if (target.equals("phonetic")) {
                        target = getCookieValue(request, "phoneticInput");
                    }
                    String map = "*:deva->" + target;
                    int idx = result.indexOf("<table");

                    if (idx != -1) // was a table returned?
                    {
                        result = result.substring(idx);  // only return the table
                        if (!target.equals("deva")) {
                            result = transformUnicodeString(result, map, 0x0900, 0x0980);
                            out.write(result.toString().getBytes("UTF-8"));
                        } else {
                            out.write(result.getBytes("UTF-8"));  // already deva
                        }
                    } else // return everything (probably an error message) but convert to target
                    {
                        idx = result.indexOf("Not found");
                        if (idx != -1) {
                            result = transformUnicodeString(result.substring(idx), map, 0x0900, 0x0980);
                        }
                        out.write(result.getBytes("UTF-8"));  // no table, probably illegal word form
                    }
                } catch (Exception ex) {
                    out.print(ex.getMessage());
                }
            } else {
                out.print(proxy.getError());
            }

            out.flush();
        } else {
            
        }
    }

    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
