/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.sanskritlibrary.proxy;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Hashtable;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.sanskritlibrary.servlet.SanskritLibraryServlet;
import org.sanskritlibrary.webservice.ByteBuffer;
import org.sanskritlibrary.webservice.UniversalProxy;

/**
 *
 * @author ralph
 */
public class NominalMorphology extends SanskritLibraryServlet {


    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        request.setAttribute("context", " <a href=\"Tools\">Tools</a> | ");
        request.setAttribute("title", "Nominal Morphology");

        // http://www.language.brown.edu/cgi-skt/decl?stem=f&lexid=&gender=m&filter=
        String stem = request.getParameter("stem");
        if (stem != null) {
            // stem=rama&gender=m&lexid=&filter=SktDevaUnicode
            ServletOutputStream out = response.getOutputStream();
            UniversalProxy proxy = new UniversalProxy();
            Hashtable<String, String> h = createHashtable(request);
            String gender = request.getParameter("gender");
            String lexid = request.getParameter("lexid");
            String format = "stem=%s&gender=%s&lexid=%s&filter=";
            String url = (String) this.getServletContext().getInitParameter("nominalMorphology");
            String params = String.format(format, stem, gender, lexid);
            h.put("x-proxy-params", params);
            if (proxy.getResponse("GET", url, h, null)) {
                try {
                    Hashtable<String, String> headers = proxy.getHeaders();
                    response.setContentType("text/html; charset=UTF-8");
                    ByteBuffer bb = proxy.getContent();
                    out.write(bb.content);
                } catch (Exception ex) {
                    out.print(ex.getMessage());
                }
            } else {
                out.print(proxy.getError());
            }

            out.flush();
        } else {
            request.setAttribute("helpfile", "helpNominalMorphology.html");
            RequestDispatcher rd = request.getRequestDispatcher("NominalMorphology.jsp");
            rd.forward(request, response);
        }
    }

    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
