/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.sanskritlibrary.proxy;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Hashtable;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.sanskritlibrary.servlet.SanskritLibraryServlet;
import org.sanskritlibrary.webservice.ByteBuffer;
import org.sanskritlibrary.webservice.UniversalProxy;

/**
 *
 * @author ralph
 */
public class VerbalMorphology extends SanskritLibraryServlet {
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        request.setAttribute("context", " <a href=\"Tools\">Tools</a> | ");
        request.setAttribute("title", "Verbal Morphology");
        // http://www.language.brown.edu/cgi-skt/conj?root=kf&tam=pre&voice=a&filter=SktDevaUnicode
        String root = request.getParameter("root");
        if (root != null) {
            // root=BU&tam=pre&voice=a&filter=SktDevaUnicode
            ServletOutputStream out = response.getOutputStream();
            UniversalProxy proxy = new UniversalProxy();
            Hashtable<String, String> h = createHashtable(request);
            String tam = request.getParameter("tam");
            String voice = request.getParameter("voice");
            String format = "root=%s&tam=%s&voice=%s";
            String url = (String) this.getServletContext().getInitParameter("verbalMorphology");
            String params = String.format(format, root, tam, voice);
            h.put("x-proxy-params", params);
            if (proxy.getResponse("GET", url, h, null)) {
                try {
                    proxy.getHeaders();
                    response.setContentType("text/html; charset=UTF-8");
                    ByteBuffer bb = proxy.getContent();
                    String result = new String(bb.content, "UTF-8");
                    String prefix = getServletContext().getInitParameter("cgisktPrefix");
                    result = result.replaceAll("\"/cgi-skt", prefix + "\"/cgi-skt");
                    out.print(result);
                } catch (Exception ex) {
                    out.print(ex.getMessage());
                }
            } else {
                out.print(proxy.getError());
            }

            out.flush();
        } else {
            request.setAttribute("helpfile", "helpVerbalMorphology.html");
            RequestDispatcher rd = request.getRequestDispatcher("VerbalMorphology.jsp");
            rd.forward(request, response);
        }
    }

    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
